#updated 20230220
#oagStringsGen.ps1

function Convert-ApplyTitleSort(
	[string]$value,
	[bool]$bEngOnly = $true,
	[bool]$bInvert = $false
) {
<#
	.SYNOPSIS
	Applies TitleSort to a string value.
	.DESCRIPTION
	This function attempts to apply TitleSort naming to a string value.
	An optional invert attempts to remove TitleSort naming from a string value.
	Not all articles are supported.
	.EXAMPLE
	.OUTPUTS
	String
#>

#updated 20211028 case insensitive, converts to same case
#updated 20211104 attempt to handle TitleSort when input value is Title:SubTitle
#updated 20211122 additional handling for unfixed No-Intro names. allow inverted on '*, [article] - *'
#updated 20221118 add limited support for articles in De, Fr, Sp
#updated 20230220 fix detection error for invert version


	[string]$sArticle = ''
	[string]$sMatch = ''
	[int]$i = 0

	if (!$value) {
		return $value
	} elseif ($value -match ' ') {
	} else {
		return $value
	}

	[System.Collections.Generic.List[String]]$sArrMatch = switch ($bEngOnly) {
		$false {@('The','A','Der','Die','La','Les','El')}
		default {@('The','A')}
	}

	if ($bInvert -eq $false) {

		ForEach ($sMatch in $sArrMatch) {
			if ($value -match '^{0} ' -f $sMatch) {
				if ($sMatch -eq 'Die') {
					if ($value -match '^Die Hard') {
					} elseif ($value -match '^Die Young') {
					} else {
						$i = 3
						break
					}
				} else {
					$i = $sMatch.length
					break
				}
			}
		}

		if ($i -gt 0) {
			$sArticle = $value.Substring(0, $i)
		}
	} else {

		ForEach ($sMatch in $sArrMatch) {
			if ($value -match ', {0} ' -f $sMatch) {

				if ($value -match ', {0}:' -f $sMatch) {
					# THIS COULD RETURN INCORRECT CASE
					$sArticle = $sMatch
					break
				} elseif ($value -match ', {0} - ' -f $sMatch) {
					# THIS COULD RETURN INCORRECT CASE
					$sArticle = $sMatch
					break
				} elseif ($value -match '\, {0}$') {
					$sArticle = $value.Substring($value.Length - $sMatch.Length)
					break
				}
			}
		}
	}

	if ($sArticle) {
		if ($bInvert -eq $false) {

			# drop leading article
			$value = $value.Substring($sArticle.length + 1)

			if ($value -match ': ') {
				# insert before colon
				$value = $value.replace(': ',', ' + $sArticle + ': ')
			} else {
				$value = $value + ', ' + $sArticle
			}
		} else {
			$value = $sArticle + ' ' + $value.replace(', ' + $sArticle,'')
		}
	}

	return $value
}